unit module Encode::Windows1252;

our %map =
    0x80 => 0x20ac,
    #0x81 => 0x0,
    0x82 => 0x201a,
    0x83 => 0x192,
    0x84 => 0x201e,
    0x85 => 0x2026,
    0x86 => 0x2020,
    0x87 => 0x2021,
    0x88 => 0x2c6,
    0x89 => 0x2030,
    0x8a => 0x160,
    0x8b => 0x2039,
    0x8c => 0x152,
    #0x8d => 0x0,
    0x8e => 0x017,
    #0x8f => 0x0,
    #0x90 => 0x0,
    0x91 => 0x2018,
    0x92 => 0x2019,
    0x93 => 0x201c,
    0x94 => 0x201d,
    0x95 => 0x2022,
    0x96 => 0x2013,
    0x97 => 0x2014,
    0x98 => 0x2dc,
    0x99 => 0x2122,
    0x9a => 0x161,
    0x9b => 0x203a,
    0x9c => 0x153,
    #0x9d => 0x0,
    0x9e => 0x17e,
    0x9f => 0x178,
    0xA0 => 0x0a0,
    0xA1 => 0x0a1,
    0xA2 => 0x0a2,
    0xA3 => 0x0a3,
    0xA4 => 0x0a4,
    0xA5 => 0x0a5,
    0xA6 => 0x0a6,
    0xA7 => 0x0a7,
    0xA8 => 0x0a8,
    0xA9 => 0x0a9,
    0xAA => 0x0aa,
    0xAB => 0x0ab,
    0xAC => 0x0ac,
    0xAD => 0x0ad,
    0xAE => 0x0ae,
    0xAF => 0x0af,
    0xB0 => 0x0b0,
    0xB1 => 0x0b1,
    0xB2 => 0x0b2,
    0xB3 => 0x0b3,
    0xB4 => 0x0b4,
    0xB5 => 0x0b5,
    0xB6 => 0x0b6,
    0xB7 => 0x0b7,
    0xB8 => 0x0b8,
    0xB9 => 0x0b9,
    0xBA => 0x0ba,
    0xBB => 0x0bb,
    0xBC => 0x0bc,
    0xBD => 0x0bd,
    0xBE => 0x0be,
    0xBF => 0x0bf,
    0xC0 => 0x0c0,
    0xC1 => 0x0c1,
    0xC2 => 0x0c2,
    0xC3 => 0x0c3,
    0xC4 => 0x0c4,
    0xC5 => 0x0c5,
    0xC6 => 0x0c6,
    0xC7 => 0x0c7,
    0xC8 => 0x0c8,
    0xC9 => 0x0c9,
    0xCA => 0x0ca,
    0xCB => 0x0cb,
    0xCC => 0x0cc,
    0xCD => 0x0cd,
    0xCE => 0x0ce,
    0xCF => 0x0cf,
    0xD0 => 0x0d0,
    0xD1 => 0x0d1,
    0xD2 => 0x0d2,
    0xD3 => 0x0d3,
    0xD4 => 0x0d4,
    0xD5 => 0x0d5,
    0xD6 => 0x0d6,
    0xD7 => 0x0d7,
    0xD8 => 0x0d8,
    0xD9 => 0x0d9,
    0xDA => 0x0da,
    0xDB => 0x0db,
    0xDC => 0x0dc,
    0xDD => 0x0dd,
    0xDE => 0x0de,
    0xDF => 0x0df,
    0xE0 => 0x0e0,
    0xE1 => 0x0e1,
    0xE2 => 0x0e2,
    0xE3 => 0x0e3,
    0xE4 => 0x0e4,
    0xE5 => 0x0e5,
    0xE6 => 0x0e6,
    0xE7 => 0x0e7,
    0xE8 => 0x0e8,
    0xE9 => 0x0e9,
    0xEA => 0x0ea,
    0xEB => 0x0eb,
    0xEC => 0x0ec,
    0xED => 0x0ed,
    0xEE => 0x0ee,
    0xEF => 0x0ef,
    0xF0 => 0x0f0,
    0xF1 => 0x0f1,
    0xF2 => 0x0f2,
    0xF3 => 0x0f3,
    0xF4 => 0x0f4,
    0xF5 => 0x0f5,
    0xF6 => 0x0f6,
    0xF7 => 0x0f7,
    0xF8 => 0x0f8,
    0xF9 => 0x0f9,
    0xFA => 0x0fa,
    0xFB => 0x0fb,
    0xFC => 0x0fc,
    0xFD => 0x0fd,
    0xFE => 0x0fe,
    0xFF => 0x0ff,
;
